@echo off
rem *** Author: T. Wittrock, RZ Uni Kiel ***

setlocal enableextensions
if errorlevel 1 goto NoExtensions

%~d0
cd "%~p0"

:EvalParam
if "%1"=="" goto NoMoreParam
if /i "%1"=="/scheduled" set SKIPIE=1
if /i "%1"=="/proxy" (
  set http_proxy=%2
  shift /1
)
shift /1
goto EvalParam
:NoMoreParam

if "%TEMP%"=="" goto NoTemp
pushd "%TEMP%"
if errorlevel 1 goto NoTempDir
popd

set CSCRIPT_PATH=%SystemRoot%\system32\cscript.exe
if not exist %CSCRIPT_PATH% goto NoCScript
if not exist ..\bin\wget.exe goto NoWGet

rem *** Copy Microsoft registry console tool ***
echo Copying Microsoft registry console tool...
if exist ..\client\bin\reg.exe goto SkipRegExe
if not exist ..\client\bin\nul md ..\client\bin
if exist %SystemRoot%\system32\reg.exe (copy %SystemRoot%\system32\reg.exe ..\client\bin) else goto NoRegExe
:SkipRegExe

rem *** Download statics ***
echo Downloading statics...
for %%i in (msi wsus) do (
  ..\bin\wget.exe -N -i ..\static\StaticDownloadLinks-%%i.txt -P ..\client\%%i
  if errorlevel 1 goto DownloadError
)
if not exist ..\client\bin\ifmember.exe (
  if not exist ..\bin\msiextract.exe goto NoMSIExtract
  ..\bin\wget.exe -N -i ..\static\StaticDownloadLink-ifmember.txt -P "%TEMP%\ifmember"
  if errorlevel 1 goto DownloadError
  "%TEMP%\ifmember\IfMember_Setup.exe" /T:"%TEMP%\ifmember" /C
  copy ..\bin\msiextract.exe "%TEMP%\ifmember" 
  pushd "%TEMP%\ifmember"
  msiextract.exe ifmember.Msi
  popd
  move "%TEMP%\ifmember\ifmember.exe" ..\client\bin > nul
  rd /S /Q "%TEMP%\ifmember"
)
for %%i in (w2k wxp w2k3 win) do (
  for %%j in (deu enu) do (
    ..\bin\wget.exe -N -i ..\static\StaticDownloadLinks-%%i-%%j.txt -P ..\src\%%i\%%j
    if errorlevel 1 goto DownloadError
  )
)

if "%SKIPIE%"=="1" goto SkipIE
rem *** Download statics for IE6 ***
for %%j in (deu enu) do (
  rem *** ie6setup.exe would otherwise delete installation files for other languages ***
  if exist ..\src\win\%%j\ie6setup\nul move ..\src\win\%%j\ie6setup ..\src\win\%%j\_ie6setup_ > nul
  ..\bin\wget.exe -N -i ..\static\StaticDownloadLinks-ie6-%%j.txt -P ..\src\win\%%j\_ie6setup_
  if errorlevel 1 (
    if exist ..\src\win\%%j\_ie6setup_\nul rd /S /Q ..\src\win\%%j\_ie6setup_
    goto DownloadError
  )
  pushd ..\src\win\%%j\_ie6setup_
  ..\..\..\..\cmd\ie6download.exe %%j
  if errorlevel 1 (
    popd
    rd /S /Q ..\src\win\%%j\_ie6setup_
    echo Warning: Download of installation files for IE6 %%j failed.
    echo          This may be caused by an existing installation of IE7.
    echo.
    pause
  ) else (
    popd
    move ..\src\win\%%j\_ie6setup_ ..\src\win\%%j\ie6setup > nul
  )
)
:SkipIE

rem *** Extract updates ***
echo Extracting updates...
%CSCRIPT_PATH% //Nologo ExtractUpdatesFromWSUS.vbs

rem *** Copy statics ***
echo Copying statics...
xcopy ..\src\*.* ..\client\*.* /S /Y

REM *** Remind build date ***
echo Reminding build date...
date /T > ..\client\builddate.txt

rem *** Create ISO images ***
for %%i in (w2k wxp w2k3) do (
  for %%j in (deu enu) do (
    call CreateISOImage.cmd %%i %%j
  )
)
call CreateISOImage.cmd all

rem *** Clean client tree ***
echo Cleaning client tree...
for %%i in (w2k wxp w2k3 win) do rd /S /Q ..\client\%%i 

goto EoF

:NoExtensions
echo.
echo ERROR: No command extensions available.
echo.
goto EoF

:NoTemp
echo.
echo ERROR: Environment variable TEMP not set.
echo.
goto Error

:NoTempDir
echo.
echo ERROR: Directory "%TEMP%" not found.
echo.
goto Error

:NoCScript
echo.
echo ERROR: VBScript interpreter %CSCRIPT_PATH% not found.
echo.
goto EoF

:NoWGet
echo.
echo ERROR: Utility ..\bin\wget.exe not found.
echo.
goto EoF

:NoMSIExtract
echo.
echo ERROR: Utility ..\bin\msiextract.exe not found.
echo.
goto EoF

:NoRegExe
echo.
echo ERROR: Utility %SystemRoot%\system32\reg.exe not found.
echo If you run Windows 2000, try to manually extract this file out of
echo the \SUPPORT\TOOLS\SUPPORT.CAB file on your installation CD and
echo copy it to the directory ..\client\bin.
echo.
goto EoF

:DownloadError
echo.
echo ERROR: Download failure.
echo.
goto EoF

:EoF
endlocal
